diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/callback.h ns-3.31/src/core/model/callback.h
--- ns-3.30.1/src/core/model/callback.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/callback.h	2020-06-27 17:38:30.000000000 -0700
@@ -1750,62 +1776,77 @@
  * \ingroup makeboundcallback
  * @{
  * Make Callbacks with two bound arguments.
+ * \tparam R    \deduced Return type of the callback
+ * \tparam TX1  \deduced Formal type of the first argument to the callback.
+ * \tparam TX2  \deduced Formal type of the second argument to the callback.
+ * \tparam ARG1 \deduced Actual type of the first bound argument.
+ * \tparam ARG2 \deduced Actual type of the second bound argument.
+ * Remaining template parameters are the types of remaining arguments
+ * to the callback.
  * \param [in] fnPtr Function pointer
  * \param [in] a1 First bound argument
- * \param [in] a2 Second bound argument 
+ * \param [in] a2 Second bound argument
  * \return A bound Callback
  */
 template <typename R, typename TX1, typename TX2, typename ARG1, typename ARG2>
-Callback<R> MakeBoundCallback (R (*fnPtr)(TX1,TX2), ARG1 a1, ARG2 a2) {
+Callback<R> MakeBoundCallback (R (*fnPtr)(TX1,TX2), ARG1 a1, ARG2 a2)
+{
   Ptr<CallbackImpl<R,empty,empty,empty,empty,empty,empty,empty,empty,empty> > impl =
-    Create<TwoBoundFunctorCallbackImpl<R (*)(TX1,TX2),R,TX1,TX2,empty,empty,empty,empty,empty,empty,empty> >(fnPtr, a1, a2);
+    Create<TwoBoundFunctorCallbackImpl<R (*)(TX1,TX2),R,TX1,TX2,empty,empty,empty,empty,empty,empty,empty> > (fnPtr, a1, a2);
   return Callback<R> (impl);
 }
 template <typename R, typename TX1, typename TX2, typename ARG1, typename ARG2,
           typename T1>
-Callback<R,T1> MakeBoundCallback (R (*fnPtr)(TX1,TX2,T1), ARG1 a1, ARG2 a2) {
+Callback<R,T1> MakeBoundCallback (R (*fnPtr)(TX1,TX2,T1), ARG1 a1, ARG2 a2)
+{
   Ptr<CallbackImpl<R,T1,empty,empty,empty,empty,empty,empty,empty,empty> > impl =
     Create<TwoBoundFunctorCallbackImpl<R (*)(TX1,TX2,T1),R,TX1,TX2,T1,empty,empty,empty,empty,empty,empty> > (fnPtr, a1, a2);
   return Callback<R,T1> (impl);
 }
 template <typename R, typename TX1, typename TX2, typename ARG1, typename ARG2,
           typename T1, typename T2>
-Callback<R,T1,T2> MakeBoundCallback (R (*fnPtr)(TX1,TX2,T1,T2), ARG1 a1, ARG2 a2) {
+Callback<R,T1,T2> MakeBoundCallback (R (*fnPtr)(TX1,TX2,T1,T2), ARG1 a1, ARG2 a2)
+{
   Ptr<CallbackImpl<R,T1,T2,empty,empty,empty,empty,empty,empty,empty> > impl =
     Create<TwoBoundFunctorCallbackImpl<R (*)(TX1,TX2,T1,T2),R,TX1,TX2,T1,T2,empty,empty,empty,empty,empty> > (fnPtr, a1, a2);
   return Callback<R,T1,T2> (impl);
 }
 template <typename R, typename TX1, typename TX2, typename ARG1, typename ARG2,
           typename T1, typename T2,typename T3>
-Callback<R,T1,T2,T3> MakeBoundCallback (R (*fnPtr)(TX1,TX2,T1,T2,T3), ARG1 a1, ARG2 a2) {
+Callback<R,T1,T2,T3> MakeBoundCallback (R (*fnPtr)(TX1,TX2,T1,T2,T3), ARG1 a1, ARG2 a2)
+{
   Ptr<CallbackImpl<R,T1,T2,T3,empty,empty,empty,empty,empty,empty> > impl =
     Create<TwoBoundFunctorCallbackImpl<R (*)(TX1,TX2,T1,T2,T3),R,TX1,TX2,T1,T2,T3,empty,empty,empty,empty> > (fnPtr, a1, a2);
   return Callback<R,T1,T2,T3> (impl);
 }
 template <typename R, typename TX1, typename TX2, typename ARG1, typename ARG2,
           typename T1, typename T2,typename T3,typename T4>
-Callback<R,T1,T2,T3,T4> MakeBoundCallback (R (*fnPtr)(TX1,TX2,T1,T2,T3,T4), ARG1 a1, ARG2 a2) {
+Callback<R,T1,T2,T3,T4> MakeBoundCallback (R (*fnPtr)(TX1,TX2,T1,T2,T3,T4), ARG1 a1, ARG2 a2)
+{
   Ptr<CallbackImpl<R,T1,T2,T3,T4,empty,empty,empty,empty,empty> > impl =
     Create<TwoBoundFunctorCallbackImpl<R (*)(TX1,TX2,T1,T2,T3,T4),R,TX1,TX2,T1,T2,T3,T4,empty,empty,empty> > (fnPtr, a1, a2);
   return Callback<R,T1,T2,T3,T4> (impl);
 }
 template <typename R, typename TX1, typename TX2, typename ARG1, typename ARG2,
           typename T1, typename T2,typename T3,typename T4,typename T5>
-Callback<R,T1,T2,T3,T4,T5> MakeBoundCallback (R (*fnPtr)(TX1,TX2,T1,T2,T3,T4,T5), ARG1 a1, ARG2 a2) {
+Callback<R,T1,T2,T3,T4,T5> MakeBoundCallback (R (*fnPtr)(TX1,TX2,T1,T2,T3,T4,T5), ARG1 a1, ARG2 a2)
+{
   Ptr<CallbackImpl<R,T1,T2,T3,T4,T5,empty,empty,empty,empty> > impl =
     Create<TwoBoundFunctorCallbackImpl<R (*)(TX1,TX2,T1,T2,T3,T4,T5),R,TX1,TX2,T1,T2,T3,T4,T5,empty,empty> > (fnPtr, a1, a2);
   return Callback<R,T1,T2,T3,T4,T5> (impl);
 }
 template <typename R, typename TX1, typename TX2, typename ARG1, typename ARG2,
           typename T1, typename T2,typename T3,typename T4,typename T5, typename T6>
-Callback<R,T1,T2,T3,T4,T5,T6> MakeBoundCallback (R (*fnPtr)(TX1,TX2,T1,T2,T3,T4,T5,T6), ARG1 a1, ARG2 a2) {
+Callback<R,T1,T2,T3,T4,T5,T6> MakeBoundCallback (R (*fnPtr)(TX1,TX2,T1,T2,T3,T4,T5,T6), ARG1 a1, ARG2 a2)
+{
   Ptr<CallbackImpl<R,T1,T2,T3,T4,T5,T6,empty,empty,empty> > impl =
     Create<TwoBoundFunctorCallbackImpl<R (*)(TX1,TX2,T1,T2,T3,T4,T5,T6),R,TX1,TX2,T1,T2,T3,T4,T5,T6,empty> > (fnPtr, a1, a2);
   return Callback<R,T1,T2,T3,T4,T5,T6> (impl);
 }
 template <typename R, typename TX1, typename TX2, typename ARG1, typename ARG2,
           typename T1, typename T2,typename T3,typename T4,typename T5, typename T6, typename T7>
-Callback<R,T1,T2,T3,T4,T5,T6,T7> MakeBoundCallback (R (*fnPtr)(TX1,TX2,T1,T2,T3,T4,T5,T6,T7), ARG1 a1, ARG2 a2) {
+Callback<R,T1,T2,T3,T4,T5,T6,T7> MakeBoundCallback (R (*fnPtr)(TX1,TX2,T1,T2,T3,T4,T5,T6,T7), ARG1 a1, ARG2 a2)
+{
   Ptr<CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,empty,empty> > impl =
     Create<TwoBoundFunctorCallbackImpl<R (*)(TX1,TX2,T1,T2,T3,T4,T5,T6,T7),R,TX1,TX2,T1,T2,T3,T4,T5,T6,T7> > (fnPtr, a1, a2);
   return Callback<R,T1,T2,T3,T4,T5,T6,T7> (impl);
@@ -1816,56 +1857,72 @@
  * \ingroup makeboundcallback
  * @{
  * Make Callbacks with three bound arguments.
+ * \tparam R    \deduced Return type of the callback
+ * \tparam TX1  \deduced Formal type of the first argument to the callback.
+ * \tparam TX2  \deduced Formal type of the second argument to the callback.
+ * \tparam TX3  \deduced Formal type of the third argument to the callback.
+ * \tparam ARG1 \deduced Actual type of the first bound argument.
+ * \tparam ARG2 \deduced Actual type of the second bound argument.
+ * \tparam ARG3 \deduced Actual type of the third bound argument.
+ * Remaining template parameters are the types of remaining arguments
+ * to the callback.
  * \param [in] a1 First bound argument
- * \param [in] a2 Second bound argument 
- * \param [in] a3 Third bound argument 
+ * \param [in] a2 Second bound argument
+ * \param [in] a3 Third bound argument
  * \param [in] fnPtr Function pointer
  * \return A bound Callback
  */
 template <typename R, typename TX1, typename TX2, typename TX3, typename ARG1, typename ARG2, typename ARG3>
-Callback<R> MakeBoundCallback (R (*fnPtr)(TX1,TX2,TX3), ARG1 a1, ARG2 a2, ARG3 a3) {
+Callback<R> MakeBoundCallback (R (*fnPtr)(TX1,TX2,TX3), ARG1 a1, ARG2 a2, ARG3 a3)
+{
   Ptr<CallbackImpl<R,empty,empty,empty,empty,empty,empty,empty,empty,empty> > impl =
-    Create<ThreeBoundFunctorCallbackImpl<R (*)(TX1,TX2,TX3),R,TX1,TX2,TX3,empty,empty,empty,empty,empty,empty> >(fnPtr, a1, a2, a3);
+    Create<ThreeBoundFunctorCallbackImpl<R (*)(TX1,TX2,TX3),R,TX1,TX2,TX3,empty,empty,empty,empty,empty,empty> > (fnPtr, a1, a2, a3);
   return Callback<R> (impl);
 }
 template <typename R, typename TX1, typename TX2, typename TX3, typename ARG1, typename ARG2, typename ARG3,
           typename T1>
-Callback<R,T1> MakeBoundCallback (R (*fnPtr)(TX1,TX2,TX3,T1), ARG1 a1, ARG2 a2, ARG3 a3) {
+Callback<R,T1> MakeBoundCallback (R (*fnPtr)(TX1,TX2,TX3,T1), ARG1 a1, ARG2 a2, ARG3 a3)
+{
   Ptr<CallbackImpl<R,T1,empty,empty,empty,empty,empty,empty,empty,empty> > impl =
     Create<ThreeBoundFunctorCallbackImpl<R (*)(TX1,TX2,TX3,T1),R,TX1,TX2,TX3,T1,empty,empty,empty,empty,empty> > (fnPtr, a1, a2, a3);
   return Callback<R,T1> (impl);
 }
 template <typename R, typename TX1, typename TX2, typename TX3, typename ARG1, typename ARG2, typename ARG3,
           typename T1, typename T2>
-Callback<R,T1,T2> MakeBoundCallback (R (*fnPtr)(TX1,TX2,TX3,T1,T2), ARG1 a1, ARG2 a2, ARG3 a3) {
+Callback<R,T1,T2> MakeBoundCallback (R (*fnPtr)(TX1,TX2,TX3,T1,T2), ARG1 a1, ARG2 a2, ARG3 a3)
+{
   Ptr<CallbackImpl<R,T1,T2,empty,empty,empty,empty,empty,empty,empty> > impl =
     Create<ThreeBoundFunctorCallbackImpl<R (*)(TX1,TX2,TX3,T1,T2),R,TX1,TX2,TX3,T1,T2,empty,empty,empty,empty> > (fnPtr, a1, a2, a3);
   return Callback<R,T1,T2> (impl);
 }
 template <typename R, typename TX1, typename TX2, typename TX3, typename ARG1, typename ARG2, typename ARG3,
           typename T1, typename T2,typename T3>
-Callback<R,T1,T2,T3> MakeBoundCallback (R (*fnPtr)(TX1,TX2,TX3,T1,T2,T3), ARG1 a1, ARG2 a2, ARG3 a3) {
+Callback<R,T1,T2,T3> MakeBoundCallback (R (*fnPtr)(TX1,TX2,TX3,T1,T2,T3), ARG1 a1, ARG2 a2, ARG3 a3)
+{
   Ptr<CallbackImpl<R,T1,T2,T3,empty,empty,empty,empty,empty,empty> > impl =
     Create<ThreeBoundFunctorCallbackImpl<R (*)(TX1,TX2,TX3,T1,T2,T3),R,TX1,TX2,TX3,T1,T2,T3,empty,empty,empty> > (fnPtr, a1, a2, a3);
   return Callback<R,T1,T2,T3> (impl);
 }
 template <typename R, typename TX1, typename TX2, typename TX3, typename ARG1, typename ARG2, typename ARG3,
           typename T1, typename T2,typename T3,typename T4>
-Callback<R,T1,T2,T3,T4> MakeBoundCallback (R (*fnPtr)(TX1,TX2,TX3,T1,T2,T3,T4), ARG1 a1, ARG2 a2, ARG3 a3) {
+Callback<R,T1,T2,T3,T4> MakeBoundCallback (R (*fnPtr)(TX1,TX2,TX3,T1,T2,T3,T4), ARG1 a1, ARG2 a2, ARG3 a3)
+{
   Ptr<CallbackImpl<R,T1,T2,T3,T4,empty,empty,empty,empty,empty> > impl =
     Create<ThreeBoundFunctorCallbackImpl<R (*)(TX1,TX2,TX3,T1,T2,T3,T4),R,TX1,TX2,TX3,T1,T2,T3,T4,empty,empty> > (fnPtr, a1, a2, a3);
   return Callback<R,T1,T2,T3,T4> (impl);
 }
 template <typename R, typename TX1, typename TX2, typename TX3, typename ARG1, typename ARG2, typename ARG3,
           typename T1, typename T2,typename T3,typename T4,typename T5>
-Callback<R,T1,T2,T3,T4,T5> MakeBoundCallback (R (*fnPtr)(TX1,TX2,TX3,T1,T2,T3,T4,T5), ARG1 a1, ARG2 a2, ARG3 a3) {
+Callback<R,T1,T2,T3,T4,T5> MakeBoundCallback (R (*fnPtr)(TX1,TX2,TX3,T1,T2,T3,T4,T5), ARG1 a1, ARG2 a2, ARG3 a3)
+{
   Ptr<CallbackImpl<R,T1,T2,T3,T4,T5,empty,empty,empty,empty> > impl =
     Create<ThreeBoundFunctorCallbackImpl<R (*)(TX1,TX2,TX3,T1,T2,T3,T4,T5),R,TX1,TX2,TX3,T1,T2,T3,T4,T5,empty> > (fnPtr, a1, a2, a3);
   return Callback<R,T1,T2,T3,T4,T5> (impl);
 }
 template <typename R, typename TX1, typename TX2, typename TX3, typename ARG1, typename ARG2, typename ARG3,
           typename T1, typename T2,typename T3,typename T4,typename T5, typename T6>
-Callback<R,T1,T2,T3,T4,T5,T6> MakeBoundCallback (R (*fnPtr)(TX1,TX2,TX3,T1,T2,T3,T4,T5,T6), ARG1 a1, ARG2 a2, ARG3 a3) {
+Callback<R,T1,T2,T3,T4,T5,T6> MakeBoundCallback (R (*fnPtr)(TX1,TX2,TX3,T1,T2,T3,T4,T5,T6), ARG1 a1, ARG2 a2, ARG3 a3)
+{
   Ptr<CallbackImpl<R,T1,T2,T3,T4,T5,T6,empty,empty,empty> > impl =
     Create<ThreeBoundFunctorCallbackImpl<R (*)(TX1,TX2,TX3,T1,T2,T3,T4,T5,T6),R,TX1,TX2,TX3,T1,T2,T3,T4,T5,T6> > (fnPtr, a1, a2, a3);
   return Callback<R,T1,T2,T3,T4,T5,T6> (impl);
@@ -1894,6 +1951,7 @@
   /**
    * Give value my callback, if type compatible
    *
+   * \tparam T \deduced The type in which to retrieve the value.
    * \param [out] value Destination callback
    * \returns \c true if successful
    */
@@ -1915,6 +1973,7 @@
    * \return \c true if successful
    */
   virtual bool DeserializeFromString (std::string value, Ptr<const AttributeChecker> checker);
+
 private:
   CallbackBase m_value;                 //!< the CallbackBase
 };
@@ -1932,7 +1991,9 @@
   if (value.CheckType (m_value))
     {
       if (!value.Assign (m_value))
-        NS_FATAL_ERROR_NO_MSG ();
+        {
+          NS_FATAL_ERROR_NO_MSG ();
+        }
       return true;
     }
   return false;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/command-line.cc ns-3.31/src/core/model/command-line.cc
--- ns-3.30.1/src/core/model/command-line.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/command-line.cc	2020-06-27 17:38:30.000000000 -0700
@@ -18,12 +18,6 @@
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
 
-#include <algorithm>  // for transform
-#include <cctype>     // for tolower
-#include <cstdlib>    // for exit
-#include <iomanip>    // for setw, boolalpha
-#include <set>
-#include <sstream>
 
 #include "command-line.h"
 #include "des-metrics.h"
@@ -34,6 +28,14 @@
 #include "type-id.h"
 #include "string.h"
 
+#include <algorithm>  // transform
+#include <cctype>     // tolower
+#include <cstdlib>    // exit, getenv
+#include <cstring>    // strlen
+#include <iomanip>    // setw, boolalpha
+#include <set>
+#include <sstream>
+
 
 /**
  * \file
@@ -47,10 +49,22 @@
 
 CommandLine::CommandLine ()
   : m_NNonOptions (0),
-    m_nonOptionCount (0)
+    m_nonOptionCount (0),
+    m_usage (),
+    m_shortName ()
 {
   NS_LOG_FUNCTION (this);
 }
+CommandLine::CommandLine (const std::string filename)
+  : m_NNonOptions (0),
+    m_nonOptionCount (0),
+    m_usage ()
+{
+  NS_LOG_FUNCTION (this << filename);
+  std::string basename = SystemPath::Split (filename).back ();
+  m_shortName = basename.substr (0, basename.rfind (".cc"));
+}
+  
 CommandLine::CommandLine (const CommandLine &cmd)
 {
   Copy (cmd);
@@ -76,8 +90,9 @@
   std::copy (cmd.m_nonOptions.begin (), cmd.m_nonOptions.end (), m_nonOptions.end ());
 
   m_NNonOptions = cmd.m_NNonOptions;
-  m_usage = cmd.m_usage;
-  m_name  = cmd.m_name;
+  m_nonOptionCount = 0;
+  m_usage       = cmd.m_usage;
+  m_shortName   = cmd.m_shortName;
 }
 void
 CommandLine::Clear (void)
@@ -95,8 +110,8 @@
   m_options.clear ();
   m_nonOptions.clear ();
   m_NNonOptions = 0;
-  m_usage = "";
-  m_name  = "";
+  m_usage       = "";
+  m_shortName   = "";
 }
 
 void
@@ -108,7 +123,7 @@
 std::string
 CommandLine::GetName () const
 {
-  return m_name;
+  return m_shortName;
 }
 
 CommandLine::Item::~Item ()
@@ -121,19 +136,25 @@
 {
   NS_LOG_FUNCTION (this << args.size () << args);
 
+  PrintDoxygenUsage ();
+  
   m_nonOptionCount = 0;
-  m_name = "";
 
   if (args.size () > 0)
     {
-      m_name = SystemPath::Split (args[0]).back ();
       args.erase (args.begin ());  // discard the program name
-      
+
       for (auto param : args)
         {
-          if (HandleOption (param)) continue;
-          if (HandleNonOption (param)) continue;
-          
+          if (HandleOption (param))
+            {
+              continue;
+            }
+          if (HandleNonOption (param))
+            {
+              continue;
+            }
+
           // is this possible?
           NS_ASSERT_MSG (false,
                          "unexpected error parsing command line parameter: '"
@@ -145,7 +166,7 @@
 #ifdef ENABLE_DES_METRICS
   DesMetrics::Get ()->Initialize (args);
 #endif
-  
+
 }
 
 bool
@@ -182,7 +203,7 @@
   else
     {
       name = arg.substr (0, cur);
-      value = arg.substr (cur + 1, arg.size () - (cur+1));
+      value = arg.substr (cur + 1, arg.size () - (cur + 1));
     }
   HandleArgument (name, value);
 
@@ -194,11 +215,11 @@
 {
   NS_LOG_FUNCTION (this << value);
 
-  if (m_nonOptionCount == m_nonOptions.size())
+  if (m_nonOptionCount == m_nonOptions.size ())
     {
       // Add an unspecified non-option as a string
       NS_LOG_LOGIC ("adding StringItem, NOCount:" << m_nonOptionCount
-                    << ", NOSize:" << m_nonOptions.size ());
+                                                  << ", NOSize:" << m_nonOptions.size ());
       StringItem * item = new StringItem;
       item->m_name = "extra-non-option-argument";
       item->m_help = "Extra non-option argument encountered.";
@@ -212,6 +233,7 @@
       std::cerr << "Invalid non-option argument value "
                 << value << " for " << i->m_name
                 << std::endl;
+      PrintHelp (std::cerr);
       std::exit (1);
     }
   ++m_nonOptionCount;
@@ -236,18 +258,18 @@
   // Hack to show just the declared non-options
   Items nonOptions (m_nonOptions.begin (),
                     m_nonOptions.begin () + m_NNonOptions);
-  os << m_name
+  os << m_shortName
      << (m_options.size ()  ? " [Program Options]" : "")
      << (nonOptions.size () ? " [Program Arguments]" : "")
      << " [General Arguments]"
      << std::endl;
-  
+
   if (m_usage.length ())
     {
       os << std::endl;
       os << m_usage << std::endl;
     }
-  
+
   std::size_t width = 0;
   for (auto it : m_options)
     {
@@ -310,6 +332,93 @@
     << std::endl;
 }
 
+#include <unistd.h>  // getcwd
+
+void
+CommandLine::PrintDoxygenUsage (void) const
+{
+  NS_LOG_FUNCTION (this);
+
+  const char * envVar = std::getenv ("NS_COMMANDLINE_INTROSPECTION");
+  if (envVar == 0 || std::strlen (envVar) == 0)
+    {
+      return;
+    }
+ 
+  if (m_shortName.size () == 0)
+    {
+      NS_FATAL_ERROR ("No file name on example-to-run; forgot to use CommandLine var (__FILE__)?");
+      return;
+    }
+
+  // Hack to show just the declared non-options
+  Items nonOptions (m_nonOptions.begin (),
+                    m_nonOptions.begin () + m_NNonOptions);
+
+  std::string outf = SystemPath::Append (std::string (envVar), m_shortName + ".command-line");
+  
+  NS_LOG_INFO ("Writing CommandLine doxy to " << outf);
+  
+  std::fstream os (outf, std::fstream::out);
+
+  
+  os << "/**\n \\file " << m_shortName << ".cc\n"
+     << "<h3>Usage</h3>\n"
+     << "<code>$ ./waf --run \"" << m_shortName
+     << (m_options.size ()  ? " [Program Options]" : "")
+     << (nonOptions.size () ? " [Program Arguments]" : "")
+     << "\"</code>\n";
+    
+  if (m_usage.length ())
+    {
+      os << m_usage << std::endl;
+    }
+
+  if (!m_options.empty ())
+    {
+      os << std::endl;
+      os << "<h3>Program Options</h3>\n"
+         << "<dl>\n";
+      for (auto i : m_options)
+        {
+          os << "  <dt>\\c --" << i->m_name << " </dt>\n"
+             << "    <dd>" << i->m_help;
+
+          if ( i->HasDefault ())
+            {
+              os << " [" << i->GetDefault () << "]";
+            }
+          os << " </dd>\n";
+        }
+      os << "</dl>\n";
+    }
+
+  if (!nonOptions.empty ())
+    {
+      os << std::endl;
+      os << "<h3>Program Arguments</h3>\n"
+         << "<dl>\n";
+      for (auto i : nonOptions)
+        {
+          os << "  <dt> \\c " << i->m_name << " </dt>\n"
+             << "    <dd>" << i->m_help;
+
+          if ( i->HasDefault ())
+            {
+              os << " [" << i->GetDefault () << "]";
+            }
+          os << " </dd>\n";
+        }
+      os << "</dl>\n";
+    }
+
+  os << "*/" << std::endl;
+
+  // All done, don't need to actually run the example
+  os.close ();
+  std::exit (0);
+}
+
 void
 CommandLine::PrintGlobals (std::ostream &os) const
 {
@@ -319,7 +428,7 @@
 
   // Sort output
   std::vector<std::string> globals;
-  
+
   for (GlobalValue::Iterator i = GlobalValue::Begin ();
        i != GlobalValue::End ();
        ++i)
@@ -354,17 +463,17 @@
     }
 
   os << "Attributes for TypeId " << tid.GetName () << std::endl;
-  
+
   // Sort output
   std::vector<std::string> attributes;
-  
+
   for (uint32_t i = 0; i < tid.GetAttributeN (); ++i)
     {
       std::stringstream ss;
       ss << "    --" << tid.GetAttributeFullName (i) << "=[";
       struct TypeId::AttributeInformation info = tid.GetAttribute (i);
       ss << info.initialValue->SerializeToString (info.checker) << "]"
-                << std::endl;
+         << std::endl;
       ss << "        " << info.help << std::endl;
       attributes.push_back (ss.str ());
     }
@@ -384,17 +493,17 @@
   NS_LOG_FUNCTION (this);
 
   os << "TypeIds in group " << group << ":" << std::endl;
-  
+
   // Sort output
   std::vector<std::string> groupTypes;
-  
+
   for (uint16_t i = 0; i < TypeId::GetRegisteredN (); ++i)
     {
       std::stringstream ss;
       TypeId tid = TypeId::GetRegistered (i);
       if (tid.GetGroupName () == group)
         {
-          ss << "    " <<tid.GetName () << std::endl;
+          ss << "    " << tid.GetName () << std::endl;
         }
       groupTypes.push_back (ss.str ());
     }
@@ -415,7 +524,7 @@
 
   // Sort output
   std::vector<std::string> types;
-    
+
   for (uint16_t i = 0; i < TypeId::GetRegisteredN (); ++i)
     {
       std::stringstream ss;
@@ -443,7 +552,7 @@
       TypeId tid = TypeId::GetRegistered (i);
       groups.insert (tid.GetGroupName ());
     }
-  
+
   os << "Registered TypeId groups:" << std::endl;
   // Sets are already sorted
   for (std::set<std::string>::const_iterator k = groups.begin ();
@@ -467,7 +576,7 @@
       // method below never returns.
       PrintHelp (std::cout);
       std::exit (0);
-    } 
+    }
   else if (name == "PrintGroups")
     {
       // method below never returns.
@@ -504,10 +613,11 @@
         {
           if (i->m_name == name)
             {
-              if (! i->Parse (value))
+              if (!i->Parse (value))
                 {
                   std::cerr << "Invalid argument value: "
                             << name << "=" << value << std::endl;
+                  PrintHelp (std::cerr);
                   std::exit (1);
                 }
               else
@@ -529,6 +639,18 @@
 }
 
 bool
+CommandLine::CallbackItem::HasDefault (void) const
+{
+  return m_default != "";
+}
+
+std::string
+CommandLine::CallbackItem::GetDefault (void) const
+{
+  return m_default;
+}
+
+bool
 CommandLine::CallbackItem::Parse (const std::string value)
 {
   NS_LOG_FUNCTION (this);
@@ -539,13 +661,16 @@
 void
 CommandLine::AddValue (const std::string &name,
                        const std::string &help,
-                       Callback<bool, std::string> callback)
+                       ns3::Callback<bool, std::string> callback,
+                       std::string defaultValue /* = "" */)
+
 {
   NS_LOG_FUNCTION (this << &name << &help << &callback);
   CallbackItem *item = new CallbackItem ();
   item->m_name = name;
   item->m_help = help;
   item->m_callback = callback;
+  item->m_default = defaultValue;
   m_options.push_back (item);
 }
 
@@ -558,7 +683,7 @@
   std::size_t colon = attributePath.rfind ("::");
   const std::string typeName = attributePath.substr (0, colon);
   NS_LOG_DEBUG ("typeName: '" << typeName << "', colon: " << colon);
-  
+
   TypeId tid;
   if (!TypeId::LookupByNameFailSafe (typeName, &tid))
     {
@@ -566,26 +691,26 @@
     }
 
   const std::string attrName = attributePath.substr (colon + 2);
-  struct TypeId::AttributeInformation info;  
+  struct TypeId::AttributeInformation info;
   if (!tid.LookupAttributeByName (attrName, &info))
     {
       NS_FATAL_ERROR ("Attribute not found: " << attributePath);
     }
-      
+
   std::stringstream ss;
   ss << info.help
      << " (" << attributePath << ") ["
      << info.initialValue->SerializeToString (info.checker) << "]";
-  
+
   AddValue (name, ss.str (),
-            MakeBoundCallback (CommandLine::HandleAttribute, attributePath)) ;
+            MakeBoundCallback (CommandLine::HandleAttribute, attributePath));
 }
 
 std::string
 CommandLine::GetExtraNonOption (std::size_t i) const
 {
   std::string value;
-  
+
   if (m_nonOptions.size () >= i + m_NNonOptions)
     {
       auto ip = dynamic_cast<StringItem *> (m_nonOptions[i + m_NNonOptions]);
@@ -624,7 +749,7 @@
     }
   return success;
 }
-    
+
 
 bool
 CommandLine::Item::HasDefault () const
@@ -650,7 +775,7 @@
 {
   return false;
 }
- 
+
 std::string
 CommandLine::StringItem::GetDefault (void) const
 {
@@ -671,11 +796,11 @@
 CommandLineHelper::UserItemParse<bool> (const std::string value, bool & val)
 {
   std::string src = value;
-  std::transform(src.begin(), src.end(), src.begin(),
-    [](char c) {return static_cast<char>(std::tolower(c)); });
+  std::transform (src.begin (), src.end (), src.begin (),
+                  [](char c) {return static_cast<char> (std::tolower (c)); });
   if (src.length () == 0)
     {
-      val = ! val;
+      val = !val;
       return true;
     }
   else if ( (src == "true") || (src == "t") )
@@ -683,7 +808,7 @@
       val = true;
       return true;
     }
-  else if ( (src == "false") || (src == "f"))
+  else if ( (src == "false") || (src == "f") )
     {
       val = false;
       return true;
@@ -697,6 +822,38 @@
     }
 }
 
+template <>
+bool
+CommandLineHelper::UserItemParse<uint8_t> (const std::string value, uint8_t & val)
+{
+  uint8_t oldVal = val;
+  long newVal;
+
+  try
+    {
+      newVal = std::stoi (value);
+    }
+  catch (std::invalid_argument & ia)
+    {
+      NS_LOG_WARN ("invalid argument: " << ia.what ());
+      val = oldVal;
+      return false;
+    }
+  catch (std::out_of_range & oor)
+    {
+      NS_LOG_WARN ("out of range: " << oor.what ());
+      val = oldVal;
+      return false;
+    }
+  if (newVal < 0 || newVal > 255)
+    {
+      return false;
+    }
+  val = newVal;
+  return true;
+}
+
+
 std::ostream &
 operator << (std::ostream & os, const CommandLine & cmd)
 {
